#include "syscall.h"

int main() {
    int numRead;
    int numWritten;
    char buf[256];

    /* Welcome message and directions */
    Write("Welcome to the Console I/O test!\n",34, ConsoleOutId );
    Write("Please enter 10 characters: ",28, ConsoleOutId );

    /* Read some stuff from console */
    numRead = 0;
    numRead = Read(buf, 10, ConsoleInId);

    /* Check if the right amount of data was read */
    if (numRead == 10) {
        Write("Read 10 characters from console: ",33,ConsoleOutId );
        Write(buf,10,ConsoleOutId);
        Write("\n", 1, ConsoleOutId );
    } else {
        Write("Read system call failed to read 10 characters!\n", 47 , ConsoleOutId );
	Exit(1);
    }

    numWritten = Write("Attempting to write partial string: ",36, ConsoleOutId);
    if( numWritten != 36 ) {
        Write("Write system call did not return numWritten\n", 44, ConsoleOutId);
	/*Exit(1);*/
    }

    numWritten = Write("hello", 2, ConsoleOutId);
    if( numWritten != 2 ) {
        Write("Write system call did not return numWritten\n", 44, ConsoleOutId);
	Exit(1);
    }

    numWritten = Write("\n",1,ConsoleOutId);
    if( numWritten != 1 ) {
        Write("Write system call did not return numWritten\n", 44, ConsoleOutId);
	Exit(1);
    }

    Write("Attempting to write string with an embedded slash zero: ", 56, ConsoleOutId);
    numWritten = Write("abc\0def", 7, ConsoleOutId);
    if( numWritten != 7 ) {
        Write("Write system call did not return numWritten\n", 44, ConsoleOutId);
	Exit(1);
    }
    Write("\n", 1, ConsoleOutId );

    Write("Testing large reads... Enter at least 130 characters:", 53, ConsoleOutId );
    numRead = Read(buf, 130, ConsoleInId);
    if( numRead >= 130 ) {
        Write("Large read successful\n", 22, ConsoleOutId );
    } else {
	Write("Large read failed!\n", 19, ConsoleOutId );
	Exit(1);
    }

    Write("\n\n Testing large write...\n", 26, ConsoleOutId);
    Write(buf, 130, ConsoleOutId);
    Write("\n\n",2, ConsoleOutId);

    Write("TEST COMPLETED SUCCESSFULLY\n", 28, ConsoleOutId );
    Exit(0);

}
